//! This file has been automatically generated by `objc2`'s `header-translator`.
//! DO NOT EDIT
use core::cell::UnsafeCell;
use core::ffi::*;
use core::marker::{PhantomData, PhantomPinned};
use core::ptr::NonNull;
#[cfg(feature = "objc2")]
use objc2::__framework_prelude::*;
use objc2_core_foundation::*;

use crate::*;

/// [Apple's documentation](https://developer.apple.com/documentation/coregraphics/cgdirectdisplayid?language=objc)
pub type CGDirectDisplayID = u32;

/// [Apple's documentation](https://developer.apple.com/documentation/coregraphics/cgopengldisplaymask?language=objc)
pub type CGOpenGLDisplayMask = u32;

/// [Apple's documentation](https://developer.apple.com/documentation/coregraphics/cgrefreshrate?language=objc)
pub type CGRefreshRate = c_double;

/// [Apple's documentation](https://developer.apple.com/documentation/coregraphics/cgdisplaymode?language=objc)
#[repr(C)]
pub struct CGDisplayMode {
    inner: [u8; 0],
    _p: UnsafeCell<PhantomData<(*const UnsafeCell<()>, PhantomPinned)>>,
}

cf_type!(
    #[encoding_name = "CGDisplayMode"]
    unsafe impl CGDisplayMode {}
);

extern "C-unwind" {
    pub fn CGMainDisplayID() -> CGDirectDisplayID;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGGetDisplaysWithPoint(
        point: CGPoint,
        max_displays: u32,
        displays: *mut CGDirectDisplayID,
        matching_display_count: *mut u32,
    ) -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGGetDisplaysWithRect(
        rect: CGRect,
        max_displays: u32,
        displays: *mut CGDirectDisplayID,
        matching_display_count: *mut u32,
    ) -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGGetDisplaysWithOpenGLDisplayMask(
        mask: CGOpenGLDisplayMask,
        max_displays: u32,
        displays: *mut CGDirectDisplayID,
        matching_display_count: *mut u32,
    ) -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGGetActiveDisplayList(
        max_displays: u32,
        active_displays: *mut CGDirectDisplayID,
        display_count: *mut u32,
    ) -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGGetOnlineDisplayList(
        max_displays: u32,
        online_displays: *mut CGDirectDisplayID,
        display_count: *mut u32,
    ) -> CGError;
}

extern "C-unwind" {
    pub fn CGDisplayIDToOpenGLDisplayMask(display: CGDirectDisplayID) -> CGOpenGLDisplayMask;
}

extern "C-unwind" {
    pub fn CGOpenGLDisplayMaskToDisplayID(mask: CGOpenGLDisplayMask) -> CGDirectDisplayID;
}

extern "C-unwind" {
    pub fn CGDisplayBounds(display: CGDirectDisplayID) -> CGRect;
}

extern "C-unwind" {
    pub fn CGDisplayPixelsWide(display: CGDirectDisplayID) -> usize;
}

extern "C-unwind" {
    pub fn CGDisplayPixelsHigh(display: CGDirectDisplayID) -> usize;
}

#[inline]
pub unsafe extern "C-unwind" fn CGDisplayCopyAllDisplayModes(
    display: CGDirectDisplayID,
    options: Option<&CFDictionary>,
) -> Option<CFRetained<CFArray>> {
    extern "C-unwind" {
        fn CGDisplayCopyAllDisplayModes(
            display: CGDirectDisplayID,
            options: Option<&CFDictionary>,
        ) -> Option<NonNull<CFArray>>;
    }
    let ret = unsafe { CGDisplayCopyAllDisplayModes(display, options) };
    ret.map(|ret| unsafe { CFRetained::from_raw(ret) })
}

extern "C" {
    /// [Apple's documentation](https://developer.apple.com/documentation/coregraphics/kcgdisplayshowduplicatelowresolutionmodes?language=objc)
    pub static kCGDisplayShowDuplicateLowResolutionModes: &'static CFString;
}

#[inline]
pub unsafe extern "C-unwind" fn CGDisplayCopyDisplayMode(
    display: CGDirectDisplayID,
) -> Option<CFRetained<CGDisplayMode>> {
    extern "C-unwind" {
        fn CGDisplayCopyDisplayMode(display: CGDirectDisplayID) -> Option<NonNull<CGDisplayMode>>;
    }
    let ret = unsafe { CGDisplayCopyDisplayMode(display) };
    ret.map(|ret| unsafe { CFRetained::from_raw(ret) })
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGDisplaySetDisplayMode(
        display: CGDirectDisplayID,
        mode: Option<&CGDisplayMode>,
        options: Option<&CFDictionary>,
    ) -> CGError;
}

extern "C-unwind" {
    pub fn CGDisplayModeGetWidth(mode: Option<&CGDisplayMode>) -> usize;
}

extern "C-unwind" {
    pub fn CGDisplayModeGetHeight(mode: Option<&CGDisplayMode>) -> usize;
}

#[deprecated = "No longer supported"]
#[inline]
pub unsafe extern "C-unwind" fn CGDisplayModeCopyPixelEncoding(
    mode: Option<&CGDisplayMode>,
) -> Option<CFRetained<CFString>> {
    extern "C-unwind" {
        fn CGDisplayModeCopyPixelEncoding(
            mode: Option<&CGDisplayMode>,
        ) -> Option<NonNull<CFString>>;
    }
    let ret = unsafe { CGDisplayModeCopyPixelEncoding(mode) };
    ret.map(|ret| unsafe { CFRetained::from_raw(ret) })
}

extern "C-unwind" {
    pub fn CGDisplayModeGetRefreshRate(mode: Option<&CGDisplayMode>) -> c_double;
}

extern "C-unwind" {
    pub fn CGDisplayModeGetIOFlags(mode: Option<&CGDisplayMode>) -> u32;
}

extern "C-unwind" {
    pub fn CGDisplayModeGetIODisplayModeID(mode: Option<&CGDisplayMode>) -> i32;
}

extern "C-unwind" {
    pub fn CGDisplayModeIsUsableForDesktopGUI(mode: Option<&CGDisplayMode>) -> bool;
}

unsafe impl ConcreteType for CGDisplayMode {
    #[doc(alias = "CGDisplayModeGetTypeID")]
    #[inline]
    fn type_id() -> CFTypeID {
        extern "C-unwind" {
            fn CGDisplayModeGetTypeID() -> CFTypeID;
        }
        unsafe { CGDisplayModeGetTypeID() }
    }
}

extern "C-unwind" {
    pub fn CGDisplayModeGetPixelWidth(mode: Option<&CGDisplayMode>) -> usize;
}

extern "C-unwind" {
    pub fn CGDisplayModeGetPixelHeight(mode: Option<&CGDisplayMode>) -> usize;
}

/// [Apple's documentation](https://developer.apple.com/documentation/coregraphics/cggammavalue?language=objc)
pub type CGGammaValue = c_float;

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGSetDisplayTransferByFormula(
        display: CGDirectDisplayID,
        red_min: CGGammaValue,
        red_max: CGGammaValue,
        red_gamma: CGGammaValue,
        green_min: CGGammaValue,
        green_max: CGGammaValue,
        green_gamma: CGGammaValue,
        blue_min: CGGammaValue,
        blue_max: CGGammaValue,
        blue_gamma: CGGammaValue,
    ) -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGGetDisplayTransferByFormula(
        display: CGDirectDisplayID,
        red_min: *mut CGGammaValue,
        red_max: *mut CGGammaValue,
        red_gamma: *mut CGGammaValue,
        green_min: *mut CGGammaValue,
        green_max: *mut CGGammaValue,
        green_gamma: *mut CGGammaValue,
        blue_min: *mut CGGammaValue,
        blue_max: *mut CGGammaValue,
        blue_gamma: *mut CGGammaValue,
    ) -> CGError;
}

extern "C-unwind" {
    pub fn CGDisplayGammaTableCapacity(display: CGDirectDisplayID) -> u32;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGSetDisplayTransferByTable(
        display: CGDirectDisplayID,
        table_size: u32,
        red_table: *const CGGammaValue,
        green_table: *const CGGammaValue,
        blue_table: *const CGGammaValue,
    ) -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGGetDisplayTransferByTable(
        display: CGDirectDisplayID,
        capacity: u32,
        red_table: *mut CGGammaValue,
        green_table: *mut CGGammaValue,
        blue_table: *mut CGGammaValue,
        sample_count: *mut u32,
    ) -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGSetDisplayTransferByByteTable(
        display: CGDirectDisplayID,
        table_size: u32,
        red_table: NonNull<u8>,
        green_table: NonNull<u8>,
        blue_table: NonNull<u8>,
    ) -> CGError;
}

extern "C-unwind" {
    pub fn CGDisplayRestoreColorSyncSettings();
}

/// [Apple's documentation](https://developer.apple.com/documentation/coregraphics/cgcaptureoptions?language=objc)
// NS_OPTIONS
#[repr(transparent)]
#[derive(Clone, Copy, Debug, PartialEq, Eq, Hash, PartialOrd, Ord)]
pub struct CGCaptureOptions(pub u32);
bitflags::bitflags! {
    impl CGCaptureOptions: u32 {
        #[doc(alias = "kCGCaptureNoOptions")]
        const NoOptions = 0;
        #[doc(alias = "kCGCaptureNoFill")]
        const NoFill = 1<<0;
    }
}

#[cfg(feature = "objc2")]
unsafe impl Encode for CGCaptureOptions {
    const ENCODING: Encoding = u32::ENCODING;
}

#[cfg(feature = "objc2")]
unsafe impl RefEncode for CGCaptureOptions {
    const ENCODING_REF: Encoding = Encoding::Pointer(&Self::ENCODING);
}

#[cfg(feature = "libc")]
#[deprecated = "No longer supported"]
#[inline]
pub unsafe extern "C-unwind" fn CGDisplayIsCaptured(display: CGDirectDisplayID) -> bool {
    extern "C-unwind" {
        fn CGDisplayIsCaptured(display: CGDirectDisplayID) -> libc::boolean_t;
    }
    let ret = unsafe { CGDisplayIsCaptured(display) };
    ret != 0
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGDisplayCapture(display: CGDirectDisplayID) -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGDisplayCaptureWithOptions(
        display: CGDirectDisplayID,
        options: CGCaptureOptions,
    ) -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGDisplayRelease(display: CGDirectDisplayID) -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGCaptureAllDisplays() -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGCaptureAllDisplaysWithOptions(options: CGCaptureOptions) -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGReleaseAllDisplays() -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGWindow")]
    pub fn CGShieldingWindowID(display: CGDirectDisplayID) -> CGWindowID;
}

extern "C-unwind" {
    #[cfg(feature = "CGWindowLevel")]
    pub fn CGShieldingWindowLevel() -> CGWindowLevel;
}

#[cfg(feature = "CGImage")]
#[deprecated = "Please use ScreenCaptureKit instead."]
#[inline]
pub unsafe extern "C-unwind" fn CGDisplayCreateImage(
    display_id: CGDirectDisplayID,
) -> Option<CFRetained<CGImage>> {
    extern "C-unwind" {
        fn CGDisplayCreateImage(display_id: CGDirectDisplayID) -> Option<NonNull<CGImage>>;
    }
    let ret = unsafe { CGDisplayCreateImage(display_id) };
    ret.map(|ret| unsafe { CFRetained::from_raw(ret) })
}

#[cfg(feature = "CGImage")]
#[deprecated = "Please use ScreenCaptureKit instead."]
#[inline]
pub unsafe extern "C-unwind" fn CGDisplayCreateImageForRect(
    display: CGDirectDisplayID,
    rect: CGRect,
) -> Option<CFRetained<CGImage>> {
    extern "C-unwind" {
        fn CGDisplayCreateImageForRect(
            display: CGDirectDisplayID,
            rect: CGRect,
        ) -> Option<NonNull<CGImage>>;
    }
    let ret = unsafe { CGDisplayCreateImageForRect(display, rect) };
    ret.map(|ret| unsafe { CFRetained::from_raw(ret) })
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGDisplayHideCursor(display: CGDirectDisplayID) -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGDisplayShowCursor(display: CGDirectDisplayID) -> CGError;
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    pub fn CGDisplayMoveCursorToPoint(display: CGDirectDisplayID, point: CGPoint) -> CGError;
}

extern "C-unwind" {
    pub fn CGGetLastMouseDelta(delta_x: *mut i32, delta_y: *mut i32);
}

#[cfg(feature = "CGContext")]
#[inline]
pub unsafe extern "C-unwind" fn CGDisplayGetDrawingContext(
    display: CGDirectDisplayID,
) -> Option<CFRetained<CGContext>> {
    extern "C-unwind" {
        fn CGDisplayGetDrawingContext(display: CGDirectDisplayID) -> Option<NonNull<CGContext>>;
    }
    let ret = unsafe { CGDisplayGetDrawingContext(display) };
    ret.map(|ret| unsafe { CFRetained::retain(ret) })
}

/// [Apple's documentation](https://developer.apple.com/documentation/coregraphics/cgdisplaycount?language=objc)
pub type CGDisplayCount = u32;

/// [Apple's documentation](https://developer.apple.com/documentation/coregraphics/cgdisplayerr?language=objc)
#[cfg(feature = "CGError")]
pub type CGDisplayErr = CGError;

#[deprecated = "No longer supported"]
#[inline]
pub unsafe extern "C-unwind" fn CGDisplayAvailableModes(
    dsp: CGDirectDisplayID,
) -> Option<CFRetained<CFArray>> {
    extern "C-unwind" {
        fn CGDisplayAvailableModes(dsp: CGDirectDisplayID) -> Option<NonNull<CFArray>>;
    }
    let ret = unsafe { CGDisplayAvailableModes(dsp) };
    ret.map(|ret| unsafe { CFRetained::retain(ret) })
}

#[cfg(feature = "libc")]
#[deprecated = "No longer supported"]
#[inline]
pub unsafe extern "C-unwind" fn CGDisplayBestModeForParameters(
    display: CGDirectDisplayID,
    bits_per_pixel: usize,
    width: usize,
    height: usize,
    exact_match: *mut libc::boolean_t,
) -> Option<CFRetained<CFDictionary>> {
    extern "C-unwind" {
        fn CGDisplayBestModeForParameters(
            display: CGDirectDisplayID,
            bits_per_pixel: usize,
            width: usize,
            height: usize,
            exact_match: *mut libc::boolean_t,
        ) -> Option<NonNull<CFDictionary>>;
    }
    let ret = unsafe {
        CGDisplayBestModeForParameters(display, bits_per_pixel, width, height, exact_match)
    };
    ret.map(|ret| unsafe { CFRetained::retain(ret) })
}

#[cfg(feature = "libc")]
#[deprecated = "No longer supported"]
#[inline]
pub unsafe extern "C-unwind" fn CGDisplayBestModeForParametersAndRefreshRate(
    display: CGDirectDisplayID,
    bits_per_pixel: usize,
    width: usize,
    height: usize,
    refresh_rate: CGRefreshRate,
    exact_match: *mut libc::boolean_t,
) -> Option<CFRetained<CFDictionary>> {
    extern "C-unwind" {
        fn CGDisplayBestModeForParametersAndRefreshRate(
            display: CGDirectDisplayID,
            bits_per_pixel: usize,
            width: usize,
            height: usize,
            refresh_rate: CGRefreshRate,
            exact_match: *mut libc::boolean_t,
        ) -> Option<NonNull<CFDictionary>>;
    }
    let ret = unsafe {
        CGDisplayBestModeForParametersAndRefreshRate(
            display,
            bits_per_pixel,
            width,
            height,
            refresh_rate,
            exact_match,
        )
    };
    ret.map(|ret| unsafe { CFRetained::retain(ret) })
}

#[deprecated = "No longer supported"]
#[inline]
pub unsafe extern "C-unwind" fn CGDisplayCurrentMode(
    display: CGDirectDisplayID,
) -> Option<CFRetained<CFDictionary>> {
    extern "C-unwind" {
        fn CGDisplayCurrentMode(display: CGDirectDisplayID) -> Option<NonNull<CFDictionary>>;
    }
    let ret = unsafe { CGDisplayCurrentMode(display) };
    ret.map(|ret| unsafe { CFRetained::retain(ret) })
}

extern "C-unwind" {
    #[cfg(feature = "CGError")]
    #[deprecated = "No longer supported"]
    pub fn CGDisplaySwitchToMode(
        display: CGDirectDisplayID,
        mode: Option<&CFDictionary>,
    ) -> CGError;
}
